#ifndef NEMO_CALDATE_H
#define NEMO_CALDATE_H

#include <nemo/fmt.h>

#ifdef __cplusplus
extern "C" {
#endif

struct caldate {
  long year;
  int month;
  int day;
};

#define CALDATE {0L,0,0}

/*
  enough space to hold:
    (signed) year, '-', 2 digit month, '-', 2 digit day,
    plus \0
*/
#define FMT_CALDATE FMT_ULONG + 7

void	caldate_frommjd(struct caldate *cd, long day, int *weekday, int *yearday);
long	caldate_mjd(const struct caldate *cd);
void	caldate_normalize(struct caldate *cd);

unsigned int	caldate_fmt(const struct caldate *cd, void *out);
unsigned int	caldate_fmt_dow(const struct caldate *cd, void *out);
unsigned int	caldate_fmt_month(const struct caldate *cd, void *out);

unsigned int	caldate_scan(struct caldate *cd, const void *in);

void	caldate_easter(struct caldate *cd);

#ifdef __cplusplus
}
#endif

#endif
