#include <nemo/fmt.h>

#include "caldate.h"

#define POSITIVE(z) (((z) < 0) ? -(z) : (z))

unsigned int caldate_fmt(const struct caldate *cd, void *out)
{
  unsigned int result;
  unsigned int i;
  long x;
  char *s;

  s = out;
  i = fmt_long(s, cd->year);
  result = i;

  if (s) {
    s += i;
    *s++ = '-';
  }
  result++;

  x = POSITIVE(cd->month);
  i = fmt_ulong0(s, (unsigned long)x, 2);
  result += i;

  if (s) {
    s += i;
    *s++ = '-';
  }
  result++;

  x = POSITIVE(cd->day);
  result += fmt_ulong0(s, (unsigned long)x, 2);

  return result;
}
