#include "caldate.h"

unsigned int caldate_scan(struct caldate *cd, const void *in)
{
  int sign;
  const char *s;
  const char *t;
  unsigned long z;
  unsigned long c;

  t = s = in;
  sign = 1;
  if (*t == '-') {
    ++t;
    sign = -1;
  }
  z = 0;
  while ((c = (unsigned char) (*t - '0')) <= 9) {
    z = z * 10 + c;
    ++t;
  }
  cd->year = (int)z * sign;

  if (*t++ != '-') return 0;
  z = 0;
  while ((c = (unsigned char) (*t - '0')) <= 9) {
    z = z * 10 + c;
    ++t;
  }
  cd->month = (int)z;

  if (*t++ != '-') return 0;
  z = 0;
  while ((c = (unsigned char) (*t - '0')) <= 9) {
    z = z * 10 + c;
    ++t;
  }
  cd->day = (int)z;

  return (unsigned int)(t - s);
}
