#include <nemo/fmt.h>

#include "caldate.h"
#include "caltime.h"

unsigned int caltime_fmt_ctime(const struct caltime *ct, void *out)
{
  unsigned int result;
  unsigned int i;
  struct caldate cd;
  char *s;

  s = out;

  caldate_frommjd(&cd, caldate_mjd(&ct->date), (int *)0, (int *)0);  /* normalise */

  i = caldate_fmt_dow(&cd, s);
  result = i;

  if (s) {
    s += i;
    *s++ = ' ';
  }
  result++;

  i = caldate_fmt_month(&cd, s);
  result += i;

  if (s) {
    s += i;
    *s++ = ' ';
  }
  result++;

  i = fmt_ulong0(s, (unsigned long)cd.day, 2);
  result += i;

  if (s) {
    s += i;
    *s++ = ' ';
  }
  result++;

  i = caltime_fmt_time(ct, s);
  result += i;

  if (s) {
    s += i;
    *s++ = ' ';
  }
  result++;

  result += fmt_long(s, cd.year);

  return result;
}
