#include <nemo/fmt.h>

#include "caldate.h"
#include "caltime.h"

static unsigned long positive(int z)
{
  return (unsigned long)((z < 0) ? -z : z);
}

unsigned int caltime_fmt_time(const struct caltime *ct, void *out)
{
  unsigned int result;
  unsigned int i;
  unsigned long x;
  char *s;

  s = out;
  x = positive(ct->hour);
  i = fmt_ulong0(s, x, 2);
  result = i;

  if (s) {
    s += i;
    *s++ = ':';
  }
  result++;

  x = positive(ct->minute);
  i = fmt_ulong0(s, x, 2);
  result += i;

  if (s) {
    s += i;
    *s++ = ':';
  }
  result++;

  x = positive(ct->second);
  result += fmt_ulong0(s, x, 2);

  return result;
}
