#include <nemo/stdint.h>
#include <nemo/unixtypes.h>

#include "leapsecs.h"
#include "caldate.h"
#include "caltime.h"

#include <time.h>

/* XXX: breaks tai encapsulation */

void caltime_local(struct caltime *ct, const struct tai *t, int *weekday, int *yearday)
{
  struct tai t2;
  time_t clock;
  struct tm *result;

  t2 = *t;
  leapsecs_sub(&t2);
  clock = (time_t)tai_epoch(&t2);
  result = localtime(&clock);

  ct->second = result->tm_sec;
  ct->minute = result->tm_min;
  ct->hour = result->tm_hour;
  ct->date.day = result->tm_mday;
  ct->date.month = result->tm_mon + 1;
  ct->date.year = result->tm_year + 1900;
  ct->offset = result->tm_gmtoff / 60L;

  if (weekday) {
    *weekday = result->tm_wday;
  }
  if (yearday) {
    *yearday = result->tm_yday;
  }
}
