#include "caldate.h"
#include "caltime.h"

unsigned int caltime_scan(struct caltime *ct, const void *in)
{
  const char *s;
  const char *t;
  unsigned long z;
  unsigned long c;
  unsigned int i;
  int sign;

  t = s = in;
  i = caldate_scan(&ct->date, t);
  if (!i) return 0;
  t += i;

  while ((*t == ' ') || (*t == '\t') || (*t == 'T')) {
    ++t;
  }
  z = 0;
  while ((c = (unsigned char) (*t - '0')) <= 9) {
    z = z * 10 + c;
    ++t;
  }
  ct->hour = (int)z;

  if (*t++ != ':') return 0;
  z = 0;
  while ((c = (unsigned char) (*t - '0')) <= 9) {
    z = z * 10 + c;
    ++t;
  }
  ct->minute = (int)z;

  if (*t != ':') {
    ct->second = 0;
  }
  else {
    ++t;
    z = 0;
    while ((c = (unsigned char) (*t - '0')) <= 9) {
      z = z * 10 + c;
      ++t;
    }
    ct->second = (int)z;
  }

  while ((*t == ' ') || (*t == '\t')) ++t;
  if (*t == '+') {
    sign = 1;
  }
  else if (*t == '-') {
    sign = -1;
  }
  else {
    return 0;
  }
  ++t;

  c = (unsigned char) (*t++ - '0');
  if (c > 9) return 0;
  z = c;

  c = (unsigned char) (*t++ - '0');
  if (c > 9) return 0;
  z = z * 10 + c;

  c = (unsigned char) (*t++ - '0');
  if (c > 9) return 0;
  z = z * 6 + c;

  c = (unsigned char) (*t++ - '0');
  if (c > 9) return 0;
  z = z * 10 + c;

  ct->offset = (long)z * sign;

  return (unsigned int)(t - s);
}
