#include "leapsecs.h"
#include "caldate.h"
#include "caltime.h"

/* XXX: breaks tai encapsulation */

void caltime_utc(struct caltime *ct, const struct tai *t, int *weekday, int *yearday)
{
  struct tai t2;
  uint64_t u;
  unsigned int leap;
  long s;

  /* XXX: check for overfow? */

  t2 = *t;
  leap = leapsecs_sub(&t2);
  u = t2.x;

  u += 58486;
  s = (long)(u % 86400ULL);

  ct->second = (int)((s % 60) + (long)leap);
  s /= 60;
  ct->minute = (int)(s % 60);
  s /= 60;
  ct->hour = (int)s;

  u /= 86400ULL;
  caldate_frommjd(&ct->date, /*XXX*/(long) (u - 53375995543064ULL), weekday, yearday);

  ct->offset = 0;
}
