#include <nemo/stdint.h>
#include <nemo/stralloc.h>
#include <nemo/djbio.h>
#include <nemo/djbiofd.h>
#include <nemo/fmt.h>
#include <nemo/scan.h>
#include <nemo/str.h>

#include "caldate.h"

static const char *dayname[7] = {
  "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

static char out[FMT_CALDATE + FMT_ULONG];

int main(int argc, char **argv)
{
  struct caldate cd;
  long day;
  int weekday;
  int yearday;
  long u;

  if (argc < 2) return 1;

  while (*++argv) {
    if (scan_long(*argv, &u) != str_len(*argv)) continue;
    cd.year = u;
    if (cd.year > 0) {
      caldate_easter(&cd);
      day = caldate_mjd(&cd);
      caldate_frommjd(&cd, day, &weekday, &yearday);
      djbio_put(djbiofd_out, dayname[weekday], 3);
      djbio_put(djbiofd_out, " ", 1);
      djbio_put(djbiofd_out, out, caldate_fmt(&cd, out));
      djbio_put(djbiofd_out, "  yearday ", 10);
      djbio_put(djbiofd_out, out, fmt_ulong(out, (unsigned long)yearday));
      djbio_put(djbiofd_out, "  mjd ", 6);
      djbio_put(djbiofd_out, out, fmt_ulong(out, (unsigned long)day));
      djbio_putflush(djbiofd_out, "\n", 1);
/*
      printf("%s %s  yearday %d  mjd %ld\n", dayname[weekday], out, yearday, day);
*/
    }
  }
  return 0;
}
