#include <nemo/stdint.h>
#include <nemo/stralloc.h>
#include <nemo/djbio.h>
#include <nemo/djbiofd.h>
#include <nemo/getln.h>
#include <nemo/macro_unused.h>

#include "leapsecs.h"
#include "caldate.h"

/* XXX: breaks tai encapsulation */

/* XXX: output here has to be binary; DOS redirection uses ASCII */

static stralloc line = STRALLOC;

int main(int argc __UNUSED__, char **argv __UNUSED__)
{
  struct caldate cd;
  struct tai t;
  byte_t x[TAI_PACK];
  long leaps;
  unsigned int match;

  leaps = 0;
  while (getln(djbiofd_in, &line, &match, '\n') != -1) {
    if (!match) break;
    if (line.s[0] == '#') continue;  /* comment */
    if (line.s[0] == '+') {
      if (caldate_scan(&cd, line.s + 1)) {
	t.x = (uint64_t)((caldate_mjd(&cd) + 1) * 86400LL + 4611686014920671114LL + leaps++);
        tai_pack(&t, x);
        djbio_put(djbiofd_out, x, TAI_PACK);
      }
    }
  }
  djbio_flush(djbiofd_out);

  return 0;
}
