#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/tai.h>
#include <nemo/taia.h>
#include <nemo/stralloc.h>
#include <nemo/djbio.h>
#include <nemo/djbiofd.h>
#include <nemo/strerr.h>
#include <nemo/fmt.h>
#include <nemo/macro_unused.h>

#include "leapsecs.h"
#include "caldate.h"
#include "caltime.h"

struct taia now;
struct tai sec;
struct caltime ct;

static char x[TAIA_FMTFRAC];
static char strnum[FMT_ULONG];

int main(int argc __UNUSED__, char **argv __UNUSED__)
{
  if (leapsecs_init() < 0) strerr_die1x(111, "utcnow: fatal: unable to init leapsecs");

  taia_now(&now);

  taia_tai(&now, &sec);
  caltime_utc(&ct, &sec, (int *)0, (int *)0);

  djbio_put(djbiofd_out, strnum, fmt_ulong(strnum, (unsigned long)ct.date.year));
  djbio_put(djbiofd_out, "-", 1);

  djbio_put(djbiofd_out, strnum, fmt_ulong0(strnum, (unsigned long)ct.date.month, 2));
  djbio_put(djbiofd_out, "-", 1);

  djbio_put(djbiofd_out, strnum, fmt_ulong0(strnum, (unsigned long)ct.date.day, 2));
  djbio_put(djbiofd_out, " ", 1);

  djbio_put(djbiofd_out, strnum, fmt_ulong0(strnum, (unsigned long)ct.hour, 2));
  djbio_put(djbiofd_out, ":", 1);

  djbio_put(djbiofd_out, strnum, fmt_ulong0(strnum, (unsigned long)ct.minute, 2));
  djbio_put(djbiofd_out, ":", 1);

  djbio_put(djbiofd_out, strnum, fmt_ulong0(strnum, (unsigned long)ct.second, 2));
  djbio_put(djbiofd_out, ".", 1);

  djbio_put(djbiofd_out, x, taia_fmtfrac(&now, x));
  djbio_putflush(djbiofd_out, "\n", 1);
/*
  printf("%ld-%02d-%02d %02d:%02d:%02d.%s\n",
    ct.date.year,
    ct.date.month,
    ct.date.day,
    ct.hour,
    ct.minute,
    ct.second,
    x);
*/
  return 0;
}
